<script lang="ts" setup>
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Product } from '@/types/Product'
import { useProductStore } from '@/stores/product'
import { useTypeStore } from '@/stores/type'
import { useAuthStore } from '@/stores/auth'
const productStore = useProductStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Image',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price',
    value: 'price'
  },
  {
    title: 'Type',
    key: 'type',
    value: (item: any | Product) => item.type?.name
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const typeStore = useTypeStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const products = ref<Product[]>([])
const authStore = useAuthStore()
let editedIndex = -1
let lastId = 4
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await productStore.deleteProduct()
  closeDelete()
}
async function editItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialog.value = true
}
async function deleteItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await productStore.saveProduct()
  closeDialog()
}

onMounted(async () => {
  await productStore.getProducts()
  await typeStore.getTypes()
})

const search = ref<string>('')

const formattedProducts = computed(() =>
  productStore.products.map((products) => ({
    ...products
  }))
)

const filteredProducts = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedProducts.value.filter((product) =>
    product.name.toLowerCase().includes(searchLower)
  )
})

const required = (v: string | boolean | number) => {
  if (typeof v === 'string') {
    return /^\d+$/.test(v) || 'Field must be a non-negative integer';
  } else if (typeof v === 'boolean') {
    return v === true || 'Field is required';
  } else if (typeof v === 'number') {
    return v >= 0 || 'Value must be greater than or equal to 0';
  }
  return true;
};

const page = ref(1)
const itemsPerPage = ref<any>(5)
const pageCount = computed(() => {
  return Math.ceil(productStore.products.length / itemsPerPage.value)
})
</script>

<template>
  <div>
    <v-row>
      <v-col cols="12" sm="12">
        <h style="font-size: 50px"><v-icon icon="mdi-food" class="mr-5"></v-icon>Product</h>
      </v-col>
      <v-col cols="12" sm="6">
        <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line
          flat hide-details variant="solo-filled"></v-text-field>
      </v-col>
      <!-- edited dialog and new product -->
      <v-col cols="12" sm="6">
        <v-dialog v-model="dialog" persistent width="600">
          <template v-slot:activator="{ props }">
            <v-btn color="success" v-bind="props"> New Product </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span>Product Profile</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-text-field v-model="productStore.editedProduct.name" :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Name"
                        variant="outlined"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field v-model.number="productStore.editedProduct.price" :readonly="loading"
                        :rules="[required]" class="mb-2" clearable label="Price" variant="outlined"
                        type="number"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-combobox v-model="productStore.editedProduct.type" :items="typeStore.types" item-title="name"
                        item-value="id" label="Select types" :return-object="true" variant="outlined"></v-combobox>
                    </v-col>
                    <v-col cols="12" sm="12" md="6">
                      <v-file-input v-model="productStore.editedProduct.files" variant="outlined" :rules="[
                        (value) => {
                          return (
                            !value ||
                            !value.length ||
                            value[0].size < 2000000 ||
                            'Image size should be less than 2 MB!'
                          )
                        }
                      ]" accept="image/png, image/jpeg, image/bmp" label="Image" placeholder="Pick an avatar"
                        prepend-icon="mdi-camera"></v-file-input>
                    </v-col>
                  </v-row>
                  <v-row justify="center">
                    <v-row justify="center">
                      <v-col cols="12" sm="12" md="4">
                        <v-img :src="`http://localhost:3000/images/products/` +
                          productStore.editedProduct.image
                          " width="200px"></v-img>
                      </v-col>
                    </v-row>
                  </v-row>
                </v-container>
              </v-form>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-col>
    </v-row>
    <v-data-table v-model:page="page" :headers="headers" :items="filteredProducts" :items-per-page="itemsPerPage">
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil</v-icon>
        <v-icon size="small" @click="deleteItem(item)" class="mr-2"> mdi-delete </v-icon>
      </template>

      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/products/' + item.image" width="100"></v-img>
      </template>
    </v-data-table>
    <v-dialog v-model="dialogDelete" max-width="500px">
      <v-card>
        <v-card-title class="font ma-4 pt-6" style="text-align: center">you want to delete this info? 🗑️</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
            @click="closeDelete">Cancel</v-btn>
          <v-spacer></v-spacer>
          <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
            @click="deleteItemConfirm">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}
</style>
